diff --git a/ldap/servers/slapd/back-ldbm/dblayer.c b/ldap/servers/slapd/back-ldbm/dblayer.c
index eaa7c301d..cd5b43cb8 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.c
+++ b/ldap/servers/slapd/back-ldbm/dblayer.c
@@ -7025,12 +1223,6 @@ dblayer_is_restored(void)
     return dblayer_post_restore;
 }
 
-void
-dblayer_set_restored(void)
-{
-    dblayer_post_restore = 1;
-}
-
 /*
  * inst_dir_name is a relative path  (from 6.21)
  *     ==> txn log stores relative paths and becomes relocatable
@@ -7117,133 +1309,6 @@ done:
     return rval;
 }
 
-/*
- * to change the db extention (e.g., .db3 -> .db4)
- */
-int
-dblayer_update_db_ext(ldbm_instance *inst, char *oldext, char *newext)
-{
-    struct attrinfo *a = NULL;
-    struct ldbminfo *li = NULL;
-    dblayer_private *priv = NULL;
-    DB *thisdb = NULL;
-    int rval = 0;
-    char *ofile = NULL;
-    char *nfile = NULL;
-    char inst_dir[MAXPATHLEN];
-    char *inst_dirp;
-
-    if (NULL == inst) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "dblayer_update_db_ext", "Null instance is passed\n");
-        return -1; /* non zero */
-    }
-    li = inst->inst_li;
-    priv = (dblayer_private *)li->li_dblayer_private;
-    inst_dirp = dblayer_get_full_inst_dir(li, inst, inst_dir, MAXPATHLEN);
-    if (NULL == inst_dirp || '\0' == *inst_dirp) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "dblayer_update_db_ext", "Instance dir is NULL\n");
-        slapi_ch_free_string(&inst_dirp);
-        return -1; /* non zero */
-    }
-    for (a = (struct attrinfo *)avl_getfirst(inst->inst_attrs);
-         NULL != a;
-         a = (struct attrinfo *)avl_getnext()) {
-        PRFileInfo64 info;
-        ofile = slapi_ch_smprintf("%s/%s%s", inst_dirp, a->ai_type, oldext);
-
-        if (PR_GetFileInfo64(ofile, &info) != PR_SUCCESS) {
-            slapi_ch_free_string(&ofile);
-            continue;
-        }
-
-        /* db->rename disable DB in it; we need to create for each */
-        rval = db_create(&thisdb, priv->dblayer_env->dblayer_DB_ENV, 0);
-        if (0 != rval) {
-            slapi_log_err(SLAPI_LOG_ERR, "dblayer_update_db_ext", "db_create returned %d (%s)\n",
-                          rval, dblayer_strerror(rval));
-            goto done;
-        }
-        nfile = slapi_ch_smprintf("%s/%s%s", inst_dirp, a->ai_type, newext);
-        slapi_log_err(SLAPI_LOG_TRACE, "dblayer_update_db_ext", "Rename %s -> %s\n",
-                      ofile, nfile);
-
-        rval = thisdb->rename(thisdb, (const char *)ofile, NULL /* subdb */,
-                              (const char *)nfile, 0);
-        if (0 != rval) {
-            slapi_log_err(SLAPI_LOG_ERR, "dblayer_update_db_ext", "Rename returned %d (%s)\n",
-                          rval, dblayer_strerror(rval));
-            slapi_log_err(SLAPI_LOG_ERR,
-                          "dblayer_update_db_ext", "Index (%s) Failed to update index %s -> %s\n",
-                          inst->inst_name, ofile, nfile);
-            goto done;
-        }
-        slapi_ch_free_string(&ofile);
-        slapi_ch_free_string(&nfile);
-    }
-
-    rval = db_create(&thisdb, priv->dblayer_env->dblayer_DB_ENV, 0);
-    if (0 != rval) {
-        slapi_log_err(SLAPI_LOG_ERR, "dblayer_update_db_ext", "db_create returned %d (%s)\n",
-                      rval, dblayer_strerror(rval));
-        goto done;
-    }
-    ofile = slapi_ch_smprintf("%s/%s%s", inst_dirp, ID2ENTRY, oldext);
-    nfile = slapi_ch_smprintf("%s/%s%s", inst_dirp, ID2ENTRY, newext);
-    slapi_log_err(SLAPI_LOG_TRACE, "dblayer_update_db_ext", "Rename %s -> %s\n",
-                  ofile, nfile);
-    rval = thisdb->rename(thisdb, (const char *)ofile, NULL /* subdb */,
-                          (const char *)nfile, 0);
-    if (0 != rval) {
-        slapi_log_err(SLAPI_LOG_ERR, "dblayer_update_db_ext", "Rename returned %d (%s)\n",
-                      rval, dblayer_strerror(rval));
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "dblayer_update_db_ext", "Index (%s) Failed to update index %s -> %s\n",
-                      inst->inst_name, ofile, nfile);
-    }
-done:
-    slapi_ch_free_string(&ofile);
-    slapi_ch_free_string(&nfile);
-    if (inst_dirp != inst_dir)
-        slapi_ch_free_string(&inst_dirp);
-
-    return rval;
-}
-
-/*
- * delete the index files belonging to the instance
- */
-int
-dblayer_delete_indices(ldbm_instance *inst)
-{
-    int rval = -1;
-    struct attrinfo *a = NULL;
-    int i;
-
-    if (NULL == inst) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "dblayer_delete_indices", "NULL instance is passed\n");
-        return rval;
-    }
-    rval = 0;
-    for (a = (struct attrinfo *)avl_getfirst(inst->inst_attrs), i = 0;
-         NULL != a;
-         a = (struct attrinfo *)avl_getnext(), i++) {
-        rval += dblayer_erase_index_file(inst->inst_be, a, i /* chkpt; 1st time only */);
-    }
-    return rval;
-}
-
-void
-dblayer_set_recovery_required(struct ldbminfo *li)
-{
-    if (NULL == li || NULL == li->li_dblayer_private) {
-        slapi_log_err(SLAPI_LOG_ERR, "dblayer_set_recovery_required", "No dblayer info\n");
-        return;
-    }
-    li->li_dblayer_private->dblayer_recovery_required = 1;
-}
 
 int
 ldbm_back_get_info(Slapi_Backend *be, int cmd, void **info)
@@ -7253,71 +1318,13 @@ ldbm_back_get_info(Slapi_Backend *be, int cmd, void **info)
         return rc;
     }
 
-    switch (cmd) {
-    case BACK_INFO_DBENV: {
-        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-        if (li) {
-            dblayer_private *prv = (dblayer_private *)li->li_dblayer_private;
-            if (prv && prv->dblayer_env && prv->dblayer_env->dblayer_DB_ENV) {
-                *(DB_ENV **)info = prv->dblayer_env->dblayer_DB_ENV;
-                rc = 0;
-            }
-        }
-        break;
-    }
-    case BACK_INFO_DBENV_OPENFLAGS: {
-        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-        if (li) {
-            dblayer_private *prv = (dblayer_private *)li->li_dblayer_private;
-            if (prv && prv->dblayer_env) {
-                *(int *)info = prv->dblayer_env->dblayer_openflags;
-                rc = 0;
-            }
-        }
-        break;
-    }
-    case BACK_INFO_INDEXPAGESIZE: {
-        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-        if (li) {
-            dblayer_private *prv = (dblayer_private *)li->li_dblayer_private;
-            if (prv && prv->dblayer_index_page_size) {
-                *(uint32_t *)info = prv->dblayer_index_page_size;
-            } else {
-                *(uint32_t *)info = DBLAYER_INDEX_PAGESIZE;
-            }
-            rc = 0;
-        }
-        break;
-    }
-    case BACK_INFO_DIRECTORY: {
-        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-        if (li) {
-            *(char **)info = li->li_directory;
-            rc = 0;
-        }
-        break;
-    }
-    case BACK_INFO_LOG_DIRECTORY: {
-        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-        if (li) {
-            *(char **)info = ldbm_config_db_logdirectory_get_ext((void *)li);
-            rc = 0;
-        }
-        break;
-    }
-    case BACK_INFO_IS_ENTRYRDN: {
-        *(int *)info = entryrdn_get_switch();
-        break;
-    }
-    case BACK_INFO_INDEX_KEY : {
-        rc = get_suffix_key(be, (struct _back_info_index_key *)info);
-        break;
-    }
-    default:
-        break;
+    struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+    if (!li) {
+        return rc;
     }
+    dblayer_private *prv = (dblayer_private *)li->li_dblayer_private;
 
-    return rc;
+    return  prv->dblayer_get_info_fn(li, cmd, info);
 }
 
 int
@@ -7348,31 +1355,13 @@ ldbm_back_ctrl_info(Slapi_Backend *be, int cmd, void *info)
         return rc;
     }
 
-    switch (cmd) {
-    case BACK_INFO_CRYPT_INIT: {
-        back_info_crypt_init *crypt_init = (back_info_crypt_init *)info;
-        rc = back_crypt_init(crypt_init->be, crypt_init->dn,
-                             crypt_init->encryptionAlgorithm,
-                             &(crypt_init->state_priv));
-        break;
-    }
-    case BACK_INFO_CRYPT_ENCRYPT_VALUE: {
-        back_info_crypt_value *crypt_value = (back_info_crypt_value *)info;
-        rc = back_crypt_encrypt_value(crypt_value->state_priv, crypt_value->in,
-                                      &(crypt_value->out));
-        break;
-    }
-    case BACK_INFO_CRYPT_DECRYPT_VALUE: {
-        back_info_crypt_value *crypt_value = (back_info_crypt_value *)info;
-        rc = back_crypt_decrypt_value(crypt_value->state_priv, crypt_value->in,
-                                      &(crypt_value->out));
-        break;
-    }
-    default:
-        break;
+    struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+    if (!li) {
+        return rc;
     }
+    dblayer_private *prv = (dblayer_private *)li->li_dblayer_private;
 
-    return rc;
+    return  prv->dblayer_back_ctrl_fn(be, cmd, info);
 }
 
 static PRUintn thread_private_txn_stack;
@@ -7399,13 +1388,13 @@ dblayer_cleanup_txn_stack(void *arg)
     return;
 }
 
-static void
+void
 dblayer_init_pvt_txn(void)
 {
     PR_NewThreadPrivateIndex(&thread_private_txn_stack, dblayer_cleanup_txn_stack);
 }
 
-static void
+void
 dblayer_push_pvt_txn(back_txn *txn)
 {
     dblayer_txn_stack *new_elem = NULL;
@@ -7420,7 +1409,7 @@ dblayer_push_pvt_txn(back_txn *txn)
     PR_APPEND_LINK(&new_elem->list, &txn_stack->list);
 }
 
-static back_txn *
+back_txn *
 dblayer_get_pvt_txn(void)
 {
     back_txn *txn = NULL;
@@ -7431,7 +1420,7 @@ dblayer_get_pvt_txn(void)
     return txn;
 }
 
-static void
+void
 dblayer_pop_pvt_txn(void)
 {
     dblayer_txn_stack *elem = NULL;
diff --git a/ldap/servers/slapd/back-ldbm/dblayer.h b/ldap/servers/slapd/back-ldbm/dblayer.h
index 5e4433e02..ba189d414 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.h
+++ b/ldap/servers/slapd/back-ldbm/dblayer.h
@@ -76,85 +76,85 @@ struct dblayer_private_env
     int dblayer_priv_flags;
 };
 
-#define DBLAYER_PRIV_SET_DATA_DIR 0x1
+typedef int dblayer_start_fn_t(struct ldbminfo *li, int flags);
+typedef int dblayer_close_fn_t(struct ldbminfo *li, int flags);
+typedef int dblayer_instance_start_fn_t(backend *be, int flags);
+typedef int dblayer_backup_fn_t(struct ldbminfo *li, char *dest_dir, Slapi_Task *task);
+typedef int dblayer_verify_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_db_size_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_ldif2db_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_db2ldif_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_cleanup_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_upgradedn_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_upgradedb_fn_t(Slapi_PBlock *pb);
+typedef int dblayer_restore_fn_t(struct ldbminfo *li, char *src_dir, Slapi_Task *task, char *bename);
+typedef int dblayer_txn_begin_fn_t(struct ldbminfo *li, back_txnid parent_txn, back_txn *txn, PRBool use_lock);
+typedef int dblayer_txn_commit_fn_t(struct ldbminfo *li, back_txn *txn, PRBool use_lock);
+typedef int dblayer_txn_abort_fn_t(struct ldbminfo *li, back_txn *txn, PRBool use_lock);
+typedef int dblayer_get_info_fn_t(struct ldbminfo *li, int cmd, void **info);
+typedef int dblayer_back_ctrl_fn_t(Slapi_Backend *be, int cmd, void *info);
+typedef int dblayer_delete_db_fn_t(struct ldbminfo *li);
+typedef int dblayer_load_dse_fn_t(struct ldbminfo *li);
+typedef int dblayer_get_db_fn_t(backend *be, char *indexname, int open_flag, struct attrinfo *ai, DB **ppDB);
+typedef int dblayer_rm_db_file_fn_t(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_chkpt);
+typedef int dblayer_import_fn_t(void *arg);
 
-/* structure which holds our stuff */
 struct dblayer_private
 {
-    struct dblayer_private_env *dblayer_env;
-    char *dblayer_home_directory;
-    char *dblayer_log_directory;
-    char *dblayer_dbhome_directory;  /* default path for relative inst paths */
-    char **dblayer_data_directories; /* passed to set_data_dir
-                                      * including dblayer_dbhome_directory */
-    char **dblayer_db_config;
-    int dblayer_ncache;
-    int dblayer_previous_ncache;
-    int dblayer_tx_max;
-    uint64_t dblayer_cachesize;
-    uint64_t dblayer_previous_cachesize; /* Cache size when we last shut down--
-                                        * used to determine if we delete
-                                        * the mpool */
-    int dblayer_recovery_required;
-    int dblayer_enable_transactions;
-    int dblayer_txn_wait; /* Default is "off" (DB_TXN_NOWAIT) but for
-                                     * support purpose it could be helpful to set
-                                     * "on" so that backend hang on deadlock */
-    int dblayer_durable_transactions;
-    int dblayer_checkpoint_interval;
-    int dblayer_circular_logging;
-    uint32_t dblayer_page_size;       /* db page size if configured,
-                                     * otherwise default to DBLAYER_PAGESIZE */
-    uint32_t dblayer_index_page_size; /* db index page size if configured,
-                                     * otherwise default to
-                                     * DBLAYER_INDEX_PAGESIZE */
-    int dblayer_idl_divisor;          /* divide page size by this to get IDL
-                                     * size */
-    uint64_t dblayer_logfile_size;    /* How large can one logfile be ? */
-    uint64_t dblayer_logbuf_size;     /* how large log buffer can be */
+    /* common params for all backen implementations */
     int dblayer_file_mode;            /* pmode for files we create */
     int dblayer_verbose;              /* Get libdb to exhale debugging info */
     int dblayer_debug;                /* Will libdb emit debugging info into
                                      * our log ? */
-    int dblayer_trickle_percentage;
-    int dblayer_cache_config; /* Special cache configurations
-                                     * e.g. force file-based mpool */
-    int dblayer_lib_version;
-    int dblayer_spin_count;         /* DB Mutex spin count, 0 == use default */
-    int dblayer_named_regions;      /* Should the regions be named sections,
-                                     * or backed by files ? */
-    int dblayer_private_mem;        /* private memory will be used for
-                                     * allocation of regions and mutexes */
-    int dblayer_private_import_mem; /* private memory will be used for
-                                     * allocation of regions and mutexes for
-                                     * import */
-    long dblayer_shm_key;           /* base segment ID for named regions */
-    int db_debug_checkpointing;     /* Enable debugging messages from
-                                     * checkpointing */
+    int dblayer_enable_transactions;
     int dblayer_bad_stuff_happened; /* Means that something happened (e.g. out
-                                     * of disk space) such that the guardian
-                                     * file must not be written on shutdown */
-    perfctrs_private *perf_private; /* Private data for performance counters
-                                     * code */
-    int dblayer_stop_threads;       /* Used to signal to threads that they
-                                     * should stop ASAP */
+                                     * of disk space)*/
+    int dblayer_idl_divisor;          /* divide page size by this to get IDL size */
+                                      /* this is legacy and should go away, but it is not BDB specific */
+
+    /* backend implementation specific data */
+    void *dblayer_env;              /* specific database environment */
+    PRLock *thread_count_lock;      /* lock for thread_count_cv */
+    PRCondVar *thread_count_cv;     /* condition variable for housekeeping thread shutdown */
     PRInt32 dblayer_thread_count;   /* Tells us how many threads are running,
                                      * used to figure out when they're all
                                      * stopped */
-    PRLock *thread_count_lock;      /* lock for thread_count_cv */
-    PRCondVar *thread_count_cv;     /* condition variable for housekeeping thread shutdown */
-    int dblayer_lockdown;           /* use DB_LOCKDOWN */
-#define BDB_LOCK_NB_MIN 10000
-    int dblayer_lock_config;
-    int dblayer_previous_lock_config;  /* Max lock count when we last shut down--
-                                      * used to determine if we delete the mpool */
-    u_int32_t dblayer_deadlock_policy; /* i.e. the atype to DB_ENV->lock_detect in deadlock_threadmain */
-    int dblayer_compactdb_interval;    /* interval to execute compact id2entry dbs */
+
+    /* functions to be provided by backend and assigned during backend init */
+    dblayer_start_fn_t *dblayer_start_fn;
+    dblayer_close_fn_t *dblayer_close_fn;
+    dblayer_instance_start_fn_t *dblayer_instance_start_fn;
+    dblayer_backup_fn_t *dblayer_backup_fn;
+    dblayer_verify_fn_t *dblayer_verify_fn;
+    dblayer_db_size_fn_t *dblayer_db_size_fn;
+    dblayer_ldif2db_fn_t *dblayer_ldif2db_fn;
+    dblayer_db2ldif_fn_t *dblayer_db2ldif_fn;
+    dblayer_cleanup_fn_t *dblayer_cleanup_fn;
+    dblayer_upgradedn_fn_t *dblayer_upgradedn_fn;
+    dblayer_upgradedb_fn_t *dblayer_upgradedb_fn;
+    dblayer_restore_fn_t *dblayer_restore_fn;
+    dblayer_txn_begin_fn_t *dblayer_txn_begin_fn;
+    dblayer_txn_commit_fn_t *dblayer_txn_commit_fn;
+    dblayer_txn_abort_fn_t *dblayer_txn_abort_fn;
+    dblayer_get_info_fn_t *dblayer_get_info_fn;
+    dblayer_back_ctrl_fn_t *dblayer_back_ctrl_fn;
+    dblayer_get_db_fn_t *dblayer_get_db_fn;
+    dblayer_delete_db_fn_t *dblayer_delete_db_fn;
+    dblayer_rm_db_file_fn_t *dblayer_rm_db_file_fn;
+    dblayer_import_fn_t *dblayer_import_fn;
+    dblayer_load_dse_fn_t *dblayer_load_dse_fn;
 };
 
+#define DBLAYER_PRIV_SET_DATA_DIR 0x1
+
+void dblayer_init_pvt_txn(void);
+void dblayer_push_pvt_txn(back_txn *txn);
+back_txn *dblayer_get_pvt_txn(void);
+void dblayer_pop_pvt_txn(void);
+
 void dblayer_log_print(const DB_ENV *dbenv, const char *prefix, const char *buffer);
 
-int dblayer_db_remove(dblayer_private_env *env, char const path[], char const dbName[]);
+int bdb_db_remove(dblayer_private_env *env, char const path[], char const dbName[]);
 
 int dblayer_delete_indices(ldbm_instance *inst);
 
diff --git a/ldap/servers/slapd/back-ldbm/dbsize.c b/ldap/servers/slapd/back-ldbm/dbsize.c
index f7cca717a..df3f525fc 100644
--- a/ldap/servers/slapd/back-ldbm/dbsize.c
+++ b/ldap/servers/slapd/back-ldbm/dbsize.c
@@ -17,18 +17,17 @@
  */
 
 #include "back-ldbm.h"
+#include "dblayer.h"
 
 /* TODO: make this a 64-bit return value */
 int
 ldbm_db_size(Slapi_PBlock *pb)
 {
     struct ldbminfo *li;
-    unsigned int size; /* TODO: make this a 64-bit return value */
-    int rc;
+    dblayer_private *priv;
 
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    rc = dblayer_database_size(li, &size);     /* TODO: make this a 64-bit return value */
-    slapi_pblock_set(pb, SLAPI_DBSIZE, &size); /* TODO: make this a 64-bit return value */
+    priv = (dblayer_private *)li->li_dblayer_private;
+    return priv->dblayer_db_size_fn(pb);
 
-    return rc;
 }
diff --git a/ldap/servers/slapd/back-ldbm/dbverify.c b/ldap/servers/slapd/back-ldbm/dbverify.c
index 793f6ea1c..8dc19802a 100644
--- a/ldap/servers/slapd/back-ldbm/dbverify.c
+++ b/ldap/servers/slapd/back-ldbm/dbverify.c
@@ -15,219 +15,12 @@
 #include "back-ldbm.h"
 #include "dblayer.h"
 
-static int
-dbverify_ext(ldbm_instance *inst, int verbose)
-{
-    char dbdir[MAXPATHLEN];
-    char *filep = NULL;
-    PRDir *dirhandle = NULL;
-    PRDirEntry *direntry = NULL;
-    DB *dbp = NULL;
-    size_t tmplen = 0;
-    size_t filelen = 0;
-    int rval = 1;
-    int rval_main = 0;
-    struct ldbminfo *li = inst->inst_li;
-    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
-    struct dblayer_private_env *pEnv = priv->dblayer_env;
-
-    dbdir[sizeof(dbdir) - 1] = '\0';
-    PR_snprintf(dbdir, sizeof(dbdir), "%s/%s", inst->inst_parent_dir_name,
-                inst->inst_dir_name);
-    if ('\0' != dbdir[sizeof(dbdir) - 1]) /* overflown */
-    {
-        slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                      "db path too long: %s/%s\n",
-                      inst->inst_parent_dir_name, inst->inst_dir_name);
-        return 1;
-    }
-    tmplen = strlen(dbdir);
-    filep = dbdir + tmplen;
-    filelen = sizeof(dbdir) - tmplen;
-
-    /* run dbverify on each each db file */
-    dirhandle = PR_OpenDir(dbdir);
-    if (!dirhandle) {
-        slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                      "PR_OpenDir (%s) failed (%d): %s\n",
-                      dbdir, PR_GetError(), slapd_pr_strerror(PR_GetError()));
-        return 1;
-    }
-    while (NULL !=
-           (direntry = PR_ReadDir(dirhandle, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        /* struct attrinfo *ai = NULL; */
-        dbp = NULL;
-
-        if (!direntry->name) {
-            break;
-        }
-        if (!strstr(direntry->name, LDBM_FILENAME_SUFFIX)) /* non db file */
-        {
-            continue;
-        }
-        if (sizeof(direntry->name) + 2 > filelen) {
-            slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                          "db path too long: %s/%s\n",
-                          dbdir, direntry->name);
-            continue;
-        }
-        PR_snprintf(filep, filelen, "/%s", direntry->name);
-        rval = db_create(&dbp, pEnv->dblayer_DB_ENV, 0);
-        if (0 != rval) {
-            slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                          "Unable to create id2entry db file %d\n", rval);
-            return rval;
-        }
-
-#define VLVPREFIX "vlv#"
-        if (0 != strncmp(direntry->name, ID2ENTRY, strlen(ID2ENTRY))) {
-            struct attrinfo *ai = NULL;
-            char *p = NULL;
-            p = strstr(filep, LDBM_FILENAME_SUFFIX); /* since already checked,
-                                                        it must have it */
-            if (p)
-                *p = '\0';
-            ainfo_get(inst->inst_be, filep + 1, &ai);
-            if (p)
-                *p = '.';
-            if (ai->ai_key_cmp_fn) {
-                dbp->app_private = (void *)ai->ai_key_cmp_fn;
-                dbp->set_bt_compare(dbp, dblayer_bt_compare);
-            }
-            if (idl_get_idl_new()) {
-                rval = dbp->set_pagesize(dbp,
-                                         (priv->dblayer_index_page_size == 0) ? DBLAYER_INDEX_PAGESIZE : priv->dblayer_index_page_size);
-            } else {
-                rval = dbp->set_pagesize(dbp,
-                                         (priv->dblayer_page_size == 0) ? DBLAYER_PAGESIZE : priv->dblayer_page_size);
-            }
-            if (0 != rval) {
-                slapi_log_err(SLAPI_LOG_ERR, "DB verify",
-                              "Unable to set pagesize flags to db (%d)\n", rval);
-                return rval;
-            }
-            if (0 == strncmp(direntry->name, VLVPREFIX, strlen(VLVPREFIX))) {
-                rval = dbp->set_flags(dbp, DB_RECNUM);
-                if (0 != rval) {
-                    slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                                  "Unable to set RECNUM flag to vlv index (%d)\n", rval);
-                    return rval;
-                }
-            } else if (idl_get_idl_new()) {
-                rval = dbp->set_flags(dbp, DB_DUP | DB_DUPSORT);
-                if (0 != rval) {
-                    slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                                  "Unable to set DUP flags to db (%d)\n", rval);
-                    return rval;
-                }
-
-                if (ai->ai_dup_cmp_fn) {
-                    /* If set, use the special dup compare callback */
-                    rval = dbp->set_dup_compare(dbp, ai->ai_dup_cmp_fn);
-                } else {
-                    rval = dbp->set_dup_compare(dbp, idl_new_compare_dups);
-                }
-
-                if (0 != rval) {
-                    slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                                  "Unable to set dup_compare to db (%d)\n", rval);
-                    return rval;
-                }
-            }
-        }
-#undef VLVPREFIX
-        rval = dbp->verify(dbp, dbdir, NULL, NULL, 0);
-        if (0 == rval) {
-            if (verbose) {
-                slapi_log_err(SLAPI_LOG_INFO, "dbverify_ext",
-                              "%s: ok\n", dbdir);
-            }
-        } else {
-            slapi_log_err(SLAPI_LOG_ERR, "dbverify_ext",
-                          "verify failed(%d): %s\n", rval, dbdir);
-        }
-        rval_main |= rval;
-        *filep = '\0';
-    }
-    PR_CloseDir(dirhandle);
-
-    return rval_main;
-}
-
 int
 ldbm_back_dbverify(Slapi_PBlock *pb)
 {
     struct ldbminfo *li = NULL;
-    Object *inst_obj = NULL;
-    ldbm_instance *inst = NULL;
-    int verbose = 0;
-    int rval = 1;
-    int rval_main = 0;
-    char **instance_names = NULL;
-    char *dbdir = NULL;
-
-    slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_dbverify", "Verifying db files...\n");
-    slapi_pblock_get(pb, SLAPI_BACKEND_INSTANCE_NAME, &instance_names);
-    slapi_pblock_get(pb, SLAPI_SEQ_TYPE, &verbose);
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    slapi_pblock_get(pb, SLAPI_DBVERIFY_DBDIR, &dbdir);
-    ldbm_config_load_dse_info(li);
-    ldbm_config_internal_set(li, CONFIG_DB_TRANSACTION_LOGGING, "off");
-
-    /* no write needed; choose EXPORT MODE */
-    if (0 != dblayer_start(li, DBLAYER_EXPORT_MODE)) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_dbverify",
-                      "dbverify: Failed to init database\n");
-        return rval;
-    }
-
-    /* server is up */
-    slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_dbverify", "server is up\n");
-    if (instance_names) /* instance is specified */
-    {
-        char **inp = NULL;
-        for (inp = instance_names; inp && *inp; inp++) {
-            inst = ldbm_instance_find_by_name(li, *inp);
-            if (inst) {
-                if (dbdir) {
-                    /* verifying backup */
-                    slapi_ch_free_string(&inst->inst_parent_dir_name);
-                    inst->inst_parent_dir_name = slapi_ch_strdup(dbdir);
-                }
-                rval_main |= dbverify_ext(inst, verbose);
-            } else {
-                rval_main |= 1; /* no such instance */
-            }
-        }
-    } else /* all instances */
-    {
-        for (inst_obj = objset_first_obj(li->li_instance_set); inst_obj;
-             inst_obj = objset_next_obj(li->li_instance_set, inst_obj)) {
-            inst = (ldbm_instance *)object_get_data(inst_obj);
-            /* check if an import/restore is already ongoing... */
-            if (instance_set_busy(inst) != 0) {
-                /* standalone, only.  never happens */
-                slapi_log_err(SLAPI_LOG_WARNING, "ldbm_back_dbverify",
-                              "Backend '%s' is already in the middle of "
-                              "another task and cannot be disturbed.\n",
-                              inst->inst_name);
-                continue; /* skip this instance and go to the next*/
-            }
-            if (dbdir) {
-                /* verifying backup */
-                slapi_ch_free_string(&inst->inst_parent_dir_name);
-                inst->inst_parent_dir_name = slapi_ch_strdup(dbdir);
-            }
-            rval_main |= dbverify_ext(inst, verbose);
-        }
-    }
-
-    /* close the database down again */
-    rval = dblayer_post_close(li, DBLAYER_EXPORT_MODE);
-    if (0 != rval) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_back_dbverify", "Failed to close database\n");
-    }
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-    return rval_main;
+    return priv->dblayer_verify_fn(pb);;
 }
diff --git a/ldap/servers/slapd/back-ldbm/idl.c b/ldap/servers/slapd/back-ldbm/idl.c
index 9725f506c..d4af9b1fa 100644
--- a/ldap/servers/slapd/back-ldbm/idl.c
+++ b/ldap/servers/slapd/back-ldbm/idl.c
@@ -14,6 +14,7 @@
 /* idl.c - ldap id list handling routines */
 
 #include "back-ldbm.h"
+#include "dblayer.h"
 
 /*
  * Disable idl locking since it causes unbreakable deadlock.
@@ -38,6 +39,29 @@ static int idl_tune = DEFAULT_IDL_TUNE; /* tuning parameters for IDL code */
 #define IDL_TUNE_BSEARCH 1              /* do a binary search when inserting into an IDL */
 #define IDL_TUNE_NOPAD 2                /* Don't pad IDLs with space at the end */
 
+/* if still needed, need to find a solution 
+ * just moved here to clenaup dblayer
+ */
+
+static int32_t
+idl_old_get_optimal_block_size(struct ldbminfo *li)
+{
+    dblayer_private *priv = NULL;
+    uint32_t *page_size = NULL;
+    PR_ASSERT(NULL != li);
+
+    priv = (dblayer_private *)li->li_dblayer_private;
+    PR_ASSERT(NULL != priv);
+
+    priv->dblayer_get_info_fn(li, BACK_INFO_DB_PAGESIZE, (void **)&page_size);
+    if (priv->dblayer_idl_divisor == 0) {
+        return *page_size - DB_EXTN_PAGE_HEADER_SIZE;
+    } else {
+        return *page_size / priv->dblayer_idl_divisor;
+    }
+}
+
+
 void
 idl_old_set_tune(int val)
 {
@@ -66,7 +90,7 @@ idl_old_get_allidslimit(struct attrinfo *a)
 static void
 idl_init_maxids(struct ldbminfo *li, idl_private *priv)
 {
-    const size_t blksize = dblayer_get_optimal_block_size(li);
+    const size_t blksize = idl_old_get_optimal_block_size(li);
 
     if (0 == li->li_allidsthreshold) {
         li->li_allidsthreshold = DEFAULT_ALLIDSTHRESHOLD;
